devices = [    
    { name: "Ailunce HD1", value: "HD1", code: 1 },
    { name: "Motorola DGP-6150+", value: "MOTO", code: 2 },
    { name: "Retevis RT52", value: "RT52", code: 3 },
    { name: "Retevis RT3S / RT90 / RT84 / RT82", value: "RT3S", code: 4 },
    { name: "AnyTone", value: "AnyTone", code: 5 },
    { name: "AnyTone (No index)", value: "AnyToneNX", code: 6 },
    { name: "Radioddity GD-77", value: "GD77", code: 7 },
    { name: "TYT MD-380 / MD-2017 / MD-9600", value: "TYT", code: 8 },
    { name: "BOAFENG DM-1701", value: "BAOFENG", code: 9 },
    { name: "DVPi", value: "DVPI", code: 10 },
    { name: "PI-Star", value: "PISTAR", code: 11 },
    { name: "Nextion (stripped)", value: "NEXTION", code: 12 },
    { name: "BlueDV", value: "BLUEDV", code: 13 },
    { name: "Abbree DM-F8", value: "DM-F8", code: 14 }
];

function getPass (callsign) {
	callsign = callsign.toUpperCase ();
	var dashLocation = callsign.indexOf ('-');
	if (dashLocation > 1)
		callsign = callsign.slice (0, dashLocation);
	var bytes = callsign.split ('');
	var one, two;
	var hash = 0x73e2;
	while (bytes.length) {
		one = bytes.shift ();
		two = bytes.shift ();
		hash = (hash ^ one.charCodeAt (0) << 8);
		if (two != undefined)
			hash = (hash ^ two.charCodeAt (0));
	}
	var result = (hash & 0x7fff);
	$("#passcode").text(result);
}

String.prototype.capitalize = function (lower) {
	return (lower ? this.toLowerCase() : this).replace(/(?:^|\s|['`.-])[^\x00-\x60^\x7B-\xDF](?!(\s|$))/g, function (a) {
		return a.toUpperCase();
	});
};

function sanity(pString)
{
	if (pString == undefined)
		return "";

	var str = "" + pString;
	if (str != null) {
		str = str.replace("\u2020", "+").replace(",", " ").normalize("NFD").replace(/[\u0300-\u036f]/g, "");
	}

	return str;
}

function getRadiopattern(pNum, pRadio, pUser)
{
	var pattern = "";
	var callsign = "";
	var fname = "";
	var name = "";
	var surname = "";
	var city = "";
	var state = "";
	var country = "";
	var  remarks = "";
	var radio_id = "";
	var id = "";

	try {                
		if (databaseIdx == 4) {
			radio_id = sanity(pUser.id);
			id = parseInt(radio_id);
			if (id < 1 || id > 16777215)
				return pattern;

			callsign = sanity(pUser.callsign);
			city = sanity(pUser.city).capitalize(true);
			state = sanity(pUser.state).capitalize(true);
			country = sanity(pUser.country).capitalize(true);

			fname = sanity(pUser.trustee).capitalize(true);
			name = sanity(pUser.ipsc_network).capitalize(true);
			surname = sanity(pUser.assigned).capitalize(true);
			remarks = sanity(pUser.ts_linked);
		} else {
			radio_id = (pUser.radio_id == null || pUser.radio_id == "") ? sanity(pUser.id) : sanity(pUser.radio_id);
			id = parseInt(radio_id);
			if (id < 1 || id > 16777215)
				return pattern;

			callsign = sanity(pUser.callsign);
			city = sanity(pUser.city).capitalize(true);
			state = sanity(pUser.state).capitalize(true);
			country = sanity(pUser.country).capitalize(true);

			fname = sanity(pUser.fname).capitalize(true);
			name = sanity(pUser.name).capitalize(true);
			surname = sanity(pUser.surname).capitalize(true);
			remarks = sanity(pUser.remarks);
		}

		if (fname == "")
			fname = name;

		wholename = (fname + " " + surname).trim();

		switch (pRadio) {
			case "AnyTone":
				pattern = pNum + "," + radio_id + "," + callsign + "," + wholename + "," + city + "," + state + "," + country + "," + remarks + ",0,0,";
				break;
			case "AnyToneNX":
				pattern = radio_id + "," + callsign + "," + wholename + "," + city + "," + state + "," + country + "," + remarks + ",0,0,";
				break;
			case "GD77":
				pattern = radio_id + "," + callsign + "," + wholename + "," + "," + city + "," + state + "," + country + ",";
				break;
			case "HD1":
				pattern = "Private Call," + callsign + " " + fname + "," + city + "," + state + "," + country + "," + radio_id;
				break;
			case "MOTO":
				pattern = "" + callsign + " " + fname + "," + radio_id;
				break;
			case "RT3S":
				pattern = radio_id + "," + callsign + "," + wholename + "," + "" + "," + city + "," + state + "," + country;
				break;
			case "RT52":
				pattern = radio_id + "," + wholename + "," + "1" + ",0," + callsign + "," + city + "," + state + "," + country + "," + "1";
				break;
			case "TYT":
				pattern = radio_id + "," + callsign + "," + wholename + "," + "," + city + "," + state + "," + country + "," + ",,,,,";
				break;
			case "BAOFENG":
				pattern = callsign + ",2," + radio_id + ",0";
				break;
			case "DVPI":
				pattern = radio_id + "," + callsign + "," + fname;
				break;
			case "PISTAR":
				pattern = radio_id + "\t" + callsign + "\t" + fname;
				break;
			case "NEXTION":
				pattern = radio_id + "," + callsign + "," + wholename + "," + city + "," + state + "," + country;
				break;
			case "BLUEDV":
				pattern = radio_id + "," + callsign + "," + wholename + "," + city + "," + state + "," + country + ",DMR";
				break;
			case "DM-F8": 
				pNum + "," + callsign + "," + "Private Call" + "," + radio_id + "," + "None" + "," + "," + city + "," + state + "," + country + "," + remarks
				break;
		}
		return pattern;
	} catch(e) {
		return pattern;
	}
}

function export_Contacts() {
	$("#devices :selected").each(function() {
		var rp;
		var subset = getCountryUsers();
		var device = $(this).val();
		
		var ext = ".csv";
		var content = "";

		$("#device_info").text("Generating " + device + " file");

		switch(device) {
			case "HD1":     content = "Call Type,Contacts Alias,City,Province,Country,Call ID\r\n"; break;
			case "MOTO":    content = "Name,radio_id\r\n"; break;
			case "RT52":    content = "Id,Name,Call Type,Call Alert,Call Sign,City,Province,Country,Remarks\r\n"; break;
			case "RT3S":    content = "Radio ID,CallSign,Name,Nickname,City,State,Country\r\n"; break;
			case "AnyTone": content = "No.,Radio ID,Callsign,Name,City,State,Country,Remarks,Call Type,Call Alert\r\n"; break;
			case "AnyToneNX": content = "Radio ID,Callsign,Name,City,State,Country,Remarks,Call Type,Call Alert\r\n"; break;
			case "GD77":    content = "Radio ID,Callsign,Name,NickName,City,State,Country,Remarks\r\n"; break;
			case "TYT":     content = "Radio ID,Callsign,Name,NickName,City,State,Country,,,,,,\r\n"; break;
			case "BAOFENG": content = "Contact Name,Call Type,Call ID,Call Receive Tone\r\n"; break;
			case "NEXTION": content = "RADIO_ID,CALLSIGN,FIRST_NAME,LAST_NAME,CITY,STATE,COUNTRY\r\n"; break;
			case "DM-F8": content = "No.,Call Alias,Call Type,Call ID,Call Alert,Repeater Number,City,State / Prov,Country,Remarks,\r\n"; break;
			case "PISTAR":  ext = ".dat";
			case "DVPI":
			case "BLUEDV":  break;
		}

		for(let i=0; i < subset.length; i++) {
			if (i % 100 == 0) {
				var percentComplete = Math.trunc((i / subset.length) * 100);
				$("#device_info").text("Exporting: " + percentComplete + " % completed");
			}

			if ((rp = getRadiopattern(i, device, subset[i])).length > 0)
				content += rp + "\r\n";
		}
		
		if (databaseIdx == "4")
			writeSingleFile("Repeaters_" + device + ext, content);
		else
			writeSingleFile("Contacts_" + device + ext, content);
	});

	$("#device_info").text("Finished Process");
}

function writeSingleFile(filename, content) {
	let blob = new Blob([content], { type: "text/plain;" });
	let link = document.createElement("a");
	window.URL = window.URL || window.webkitURL;
	link.download = filename;
	link.href = window.URL.createObjectURL(blob);
	link.style.display = "none";
	document.body.appendChild(link);
	link.click();

	setTimeout(() => {
		document.body.removeChild(link);
		window.URL.revokeObjectURL(link.href);
	}, 250);
}

function readSingleFile(file) {
	if (file) {
		var reader = new FileReader();
		reader.addEventListener('loadend', function() {
			if (reader.result != null) {
				userJson = JSON.parse(reader.result); 
				
				if (userJson.results != null) {
					userJson = userJson.results;
					databaseIdx = "1";
					$('#databaseList option[idx='+databaseIdx+']').prop('selected', true);
				} else if (userJson.users != null) {
						userJson = userJson.users;
						databaseIdx = "2";
						$('#databaseList option[idx='+databaseIdx+']').prop('selected', true);
				}
				else {
					userJson = [];
				}
			}
		});

		reader.readAsText(file);
	}
}

function getCountryUsers() {
	var subset = [];

	var all = $('#chkAll').is(":checked");
	var noCountries = $('#chkNoCountries').is(":checked");

	if (all) {
		if (noCountries)
			for(let i=0; i < userJson.length; i++) {
				if (userJson[i].country ==  null || userJson[i].country == "")
					subset.push(userJson[i]);
		}
		else {
			subset = userJson;
		}
	} else {
		var countrySet = new Set();

		$("#countries :selected").each(function() {
			countrySet.add($(this).val()); 
		});

		for(let i=0; i < userJson.length; i++) {
			if (countrySet.has(userJson[i].country))
				subset.push(userJson[i]);
		}
	}

	return subset;
}

function RecordsPerCountry(cc) {
	var count = 0;

	if (userJson != null) {
		for(let i=0; i < userJson.length; i++) {
			if (userJson[i].country ==  cc)
				count++;
		}
	}
	return count;
}

function NumberOfRecords() {
	var count = 0;

	var all = $('#chkAll').is(":checked");
	var noCountries = $('#chkNoCountries').is(":checked");

	if (all) {
		if (noCountries) {
			for(let i=0; i < userJson.length; i++) {
				if (userJson[i].country ==  null || userJson[i].country == "")
					count++;
			}
		}
		else {
			count = userJson.length;
		}
	} else {
		var countrySet = new Set();

		$("#countries :selected").each(function() {
			countrySet.add($(this).val()); 
		});

		for(let i=0; i < userJson.length; i++) {
			if (countrySet.has(userJson[i].country))
				count++;
		}
	}

	return count;
}

function compare( a, b ) {
	if ( a.country < b.country ){
		return -1;
	}
	if ( a.country > b.country ){
		return 1;
	}
	return 0;
}

function updateProgress (evt) {
	if (evt.lengthComputable) {
		var percentComplete = Math.trunc((evt.loaded / evt.total) * 100);
		$("#loaded").text("Downloading: " + percentComplete + " % completed");
	} else {
		$("#loaded").text("Downloading...");
	}
}

function updateCountriesUI() {
	setTimeout(() => {
		var flag = !$("#countries option").length;
		$("#countries").prop("disabled", flag);
		$("#chkAll").prop("disabled", flag);
		$("#chkNoCountries").prop("disabled", flag);
	}, 125);
}

function updateDevicesUI() {
	setTimeout(() => {
		var flag = NumberOfRecords() == 0;
		$("#devices").prop("disabled", flag);
		$("#export").prop("disabled", flag);
	}, 125);
}

function transferComplete(evt) {
	$('#countries').empty();

	if (userJson.length > 0) {
		$("#loaded").text("Wait... Sorting and normalizing country names");

		if (Array.isArray(userJson) && userJson[0].results != null)
			userJson = userJson[0].results;

		userJson.sort(compare);

		for(let i=0; i < userJson.length; i++)
			userJson[i].country = userJson[i].country.capitalize(true);

		for(let i=0; i < userJson.length; i++) {
			var country = userJson[i].country;

			if (country != "" && !$("#countries option[value='"+country+"']").length) {
				var nb = RecordsPerCountry(country)
				if (nb > 0)
					$('#countries').append($('<option></option>').attr('users', nb).val(country).text(country + " (" + nb + ")"));
			}
		}

		var nb = RecordsPerCountry("");
		if (nb > 0)
			$('#countries').append($('<option></option>').attr('users', nb).val("").text("Undefined" + " (" + nb + ")"));

		setTimeout(() => {
			$('#chkAll').prop("checked", true);
			$('#countries option').prop('selected', true);

			$("#loaded").text("Loading completed");
			$("#update").attr("disabled", false);
			$("#nbcontacts").text(NumberOfRecords());
		
			updateCountriesUI();
			updateDevicesUI();
		}, 1000);
	}
}

function transferFailed(evt) {
	$("#loaded").text("Download Error - Please Try Again");
	$("#update").attr("disabled", false);
	$("#nbcontacts").text(NumberOfRecords());

	setTimeout(() => {
		updateCountriesUI();
		updateDevicesUI();
	}, 250);
}

function transferCanceled(evt) {
	$("#loaded").text("Download Cancelled by User");
	$("#update").attr("disabled", false);
	$("#nbcontacts").text(NumberOfRecords());

	setTimeout(() => {
		updateCountriesUI();
		updateDevicesUI();
	}, 250);
}

function log(msg) {
	console.log(msg);
};

function createCORSRequest(method, url) {
	var xhr = new XMLHttpRequest();
	if ("withCredentials" in xhr)
		xhr.open(method, url, true);
	else if (typeof XDomainRequest != "undefined") {
		xhr = new XDomainRequest();
		xhr.open(method, url);
	} else {
		xhr = null;
	}

	return xhr;
}

function download(filename) {
	userJson = [];
	$("#loaded").text("User list download starting");

	const url = filename;
	var headers = new Headers({
		'Content-Type': 'application/json'
	});
	
	var xhr = createCORSRequest("GET", filename);

	xhr.onreadystatechange = function () {
		if (xhr.readyState === 4 && xhr.status === 200) {
			$("#update").attr("disabled", false);

			userJson = JSON.parse(xhr.responseText);

			switch(databaseIdx) {
				case "1":
				case "5":
					userJson = userJson.results;
					break;

				case "2":
				case "3":
					userJson = userJson.users;
					break;

				case "4":
					userJson = userJson.rptrs;
					break;

				default:
					break;
			}
				
			if (!Array.isArray(userJson))
				userJson = [userJson];
		}
	};            

	xhr.addEventListener("progress", updateProgress, false);
	xhr.addEventListener("load", transferComplete, false);
	xhr.addEventListener("error", transferFailed, false);
	xhr.addEventListener("abort", transferCanceled, false);
	xhr.send();
}

$(document).ready(function() {
	socket = null;
	userJson = [];

	if (window.File && window.FileReader && window.FileList && window.Blob) {
		devices.forEach(function(e, i){
			$('#devices').append($('<option></option>').val(e.value).text(e.name)); 
		});

		$(document).on("change", "#countries", function() {
			$('#chkAll').prop('checked', false);
			$("#nbcontacts").text(NumberOfRecords());
			updateDevicesUI();
		});

		$(document).on("change", "#chkAll", function() {
			$('#countries option').prop('selected', this.checked);
			$('#chkNoCountries').prop('checked', false);
			$("#nbcontacts").text(NumberOfRecords());
			updateDevicesUI();
		});

		$(document).on("change", "#chkNoCountries", function() {
			$('#countries option').prop('selected', false);
			$('#chkAll').prop('checked', false);
			$("#nbcontacts").text(NumberOfRecords());
			updateDevicesUI();
		});

		$(document).on("change", "#databaseList", function() {
			$('#countries').empty();
			databaseIdx = $(this).find(':selected').attr('idx');
			database = this.value;
			
			$("#loaded").text("");
			updateCountriesUI();
			updateDevicesUI();
		});

		$(document).on("click", "#update", function() {
			$("#update").attr("disabled", true);
			download(database);
		});

		$(document).on("click", "#export", function() {
			export_Contacts();
		});

		$(document).on("click", "#generate", function() {
			getPass($('#callsign').val());
		});

		$("#databaseList").change();
		$("#export").prop("disabled", !NumberOfRecords() || !$("#devices :selected").length);
	} else
		alert('The File APIs are not fully supported in this browser.');
});
